;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-beginner-reader.ss" "lang")((modname Hausi9_a3_neu) (read-case-sensitive #t) (teachpacks ((lib "image.rkt" "teachpack" "2htdp") (lib "universe.rkt" "teachpack" "2htdp"))) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ((lib "image.rkt" "teachpack" "2htdp") (lib "universe.rkt" "teachpack" "2htdp")) #f)))
(define WIDTH 200)
(define HEIGHT 200)
(define BALL-RADIUS 10)
(define BALL-IMG (circle BALL-RADIUS "solid" "red"))
(define RANGLE-LENGTH 20)
(define HALF-RANGLE (/ RANGLE-LENGTH 2))
(define SPEC-DISTANCE (+ BALL-RADIUS HALF-RANGLE))
(define BACKGROUND (empty-scene WIDTH HEIGHT))

(define WELCOME-SCREEN (place-image
                        (text "WELCOME TO BREAKOUT" 15 "black")
                        (/ WIDTH 2) (/ HEIGHT 2)
                        (place-image
                         (text "click to start" 10 "blue")
                         (/ WIDTH 2) (+ (/ HEIGHT 2) 20)
                         BACKGROUND)))

(define GAME-OVER-SCREEN (place-image
                          (text "GAME OVER" 20 "red")
                          (/ WIDTH 2) (/ HEIGHT 2)
                          BACKGROUND))

(define WINNER-SCREEN (place-image
                       (text "WINNER WINNER" 20 "blue")
                       (/ WIDTH 2) (- (/ HEIGHT 2) 10)
                       (place-image
                        (text "CHICKEN DINNER" 20 "blue")
                        (/ WIDTH 2) (+ 10 (/ HEIGHT 2))
                        BACKGROUND)))

(define RACKET-W 40)
; interp. the width of the racket
(define RACKET-H 10)
; interp. the height of the racket
(define RACKET-IMG (rectangle RACKET-W RACKET-H "solid" "blue"))

 
(define-struct vel (delta-x delta-y))
; a Vel is a structure: (make-vel Number Number)
; interp. the velocity vector of a moving object
 
(define-struct ball (loc velocity))
; a Ball is a structure: (make-ball Posn Vel)
; interp. the position and velocity of a object
(define INITIAL-BALL (make-ball (make-posn 180 100)
                                (make-vel 1 2)))
(define SECOND-BALL (make-ball (make-posn 89 54)
                               (make-vel -3 1)))

; A Colour is one of
; - "red"
; - "green"
; interp. a colour of a rangle
(define GREEN "green")
(define RED "red")
(define BLUE "blue")

(define-struct rangle (loc col))
; a Rangle is a structure: (make-rangle Posn Colour)
; interp, a rectangle that appears on top of the screen during the game
(define RANGLE-1 (make-rangle (make-posn 20 15) RED))
(define RANGLE-2 (make-rangle (make-posn 50 15) GREEN))
(define RANGLE-3 (make-rangle (make-posn 80 15) RED))
(define RANGLE-4 (make-rangle (make-posn 110 15) GREEN))
(define RANGLE-5 (make-rangle (make-posn 140 15) RED))
(define RANGLE-6 (make-rangle (make-posn 170 15) GREEN))
(define RANGLE-7 (make-rangle (make-posn 20 45) GREEN))
(define RANGLE-8 (make-rangle (make-posn 50 45) RED))
(define RANGLE-9 (make-rangle (make-posn 80 45) GREEN))
(define RANGLE-10 (make-rangle (make-posn 110 45) RED))
(define RANGLE-11 (make-rangle (make-posn 140 45) GREEN))
(define RANGLE-12 (make-rangle (make-posn 170 45) RED))
(define RANGLE-13 (make-rangle (make-posn 110 45) BLUE))
(define RANGLE-14 (make-rangle (make-posn 110 75) BLUE))
(define (rangle-template ran)
  (...(make-rangle (make-posn 52 45) GREEN)...(rangle-col ran)...(make-loc ran)...(rangle? ran)...))

; a Rangle-List is one of
; - empty
; - (list rangle rangle-list)
; interp. a list of rangles
(define EMPTY empty)
(define RANGLE-LIST-1 (list RANGLE-1 
                            RANGLE-2
                            RANGLE-3 
                            RANGLE-4
                            RANGLE-5
                            RANGLE-6 
                            RANGLE-7
                            RANGLE-8
                            RANGLE-9
                            RANGLE-10
                            RANGLE-11
                            RANGLE-12
                            RANGLE-14))
(define (rangle-list-template ran-lst)
  (cond
    [(empty? ran-lst)...]
    [(cons? ran-lst) (... (first ran-lst)...(rangle-list-template ran-lst)...)]))

; A MaybeRangle is one of
; - a Rangle
; - #false
; interp. a rectangle or #false which means no rectangle is affected
(define (maybe-rangle-template mran)
  (cond
    [(false? mran)...]
    [(rangle? mran) (...(rangle-loc mran)...(rangle-col mran)...)]))

; A Racket is a number
; interp. the horizontal position of an object
(define INITIAL-RACKET 100)
(define SECOND-RACKET 150)

; A worldstate is one of
; - "welcome"
; - "game-over"
; - "winner"
; - worldstate 
(define WELCOME "welcome")
(define GAME-OVER "game-over")
(define WINNER "winner")

(define-struct worldstate (ball racket rangle-list))
; WorldState is a struct (make-worldstate ball racket rangle-list)
; interp. the current state of the ball and of the racket
(define (worldstate-template state)
  (cond
    [(and (string? state) (string=? WELCOME state))...]
    [(and (string? state) (string=? GAME-OVER state))...]
    [(and (string? state) (string=? WINNER state))...]
    [(worldstate? state) (...(worldstate-ball state)...(worldstate-racket state)...(worldstate-rangle-list state)...)]))
(define INITIAL-WORLD-STATE WELCOME)
(define FIRST-WORLD-STATE (make-worldstate INITIAL-BALL INITIAL-RACKET RANGLE-LIST-1))
(define SECOND-WORLD-STATE (make-worldstate SECOND-BALL SECOND-RACKET RANGLE-LIST-1))
(define THIRD-WORLD-STATE GAME-OVER)
(define FOURTH-WORLD-STATE WINNER)

; A MouseEvent is one of
; - "button-down"
; - "button-up"
; - "drag"
; - "move"
; - "enter"
; - "leave"
; interp. mouse events, e.g., mouse movements or mouse clicks
(define MOVE "move")
(define CLICK "button-down")

; rangle-img
;
; rangle -> image
; makes an image of a given rangle
(check-expect (rangle-img RANGLE-1) (square RANGLE-LENGTH "solid" RED))
(define (rangle-img ran)
  (square RANGLE-LENGTH "solid" (rangle-col ran)))

; render-rangles
;
; rangle-list -> image
; renders all rangles of a list
(check-expect (image? (render-rangles RANGLE-LIST-1)) #true)
(define (render-rangles lst)
  (cond
    [(empty? lst) (empty-scene HEIGHT WIDTH)]
    [(cons? lst) (place-image (rangle-img (first lst))
                              (posn-x (rangle-loc (first lst)))
                              (posn-y (rangle-loc (first lst)))
                              (render-rangles (rest lst)))]))
; ball-hit-rangle-top/down?
;
; Worldstate -> boolean
; checks, whether the ball hit a rangle on top or downside or not
(check-expect (ball-hit-rangle-top/down? (make-worldstate (make-ball (make-posn 50 50)
                                                                     (make-vel 1 1))
                                                          78
                                                          (list (make-rangle (make-posn 50 60) GREEN)))) #true)
(check-expect (ball-hit-rangle-top/down? (make-worldstate (make-ball (make-posn 50 50)
                                                                     (make-vel 1 1))
                                                          78
                                                          (list (make-rangle (make-posn 50 10) GREEN)))) #false)
(define (ball-hit-rangle-top/down? state)
  (and 
   (<= (abs (- (posn-x (ball-loc (worldstate-ball state)))
               (posn-x (rangle-loc (first (worldstate-rangle-list state))))))
       HALF-RANGLE)
   (<= (abs (- (posn-y (ball-loc (worldstate-ball state)))
               (posn-y (rangle-loc (first (worldstate-rangle-list state))))))
       SPEC-DISTANCE)))

; ball-hit-rangle-left/right?
;
; Worldstate -> boolean
; checks, whether the ball hit a rangle on the left or right side or not
(check-expect (ball-hit-rangle-top/down? (make-worldstate (make-ball (make-posn 50 50)
                                                                     (make-vel 1 1))
                                                          78
                                                          (list (make-rangle (make-posn 60 50) GREEN)))) #true)
(check-expect (ball-hit-rangle-top/down? (make-worldstate (make-ball (make-posn 50 50)
                                                                     (make-vel 1 1))
                                                          78
                                                          (list (make-rangle (make-posn 50 10) GREEN)))) #false)
(define (ball-hit-rangle-left/right? state)
  (and 
   (<= (abs (- (posn-y (ball-loc (worldstate-ball state)))
               (posn-y (rangle-loc (first (worldstate-rangle-list state))))))
       HALF-RANGLE)
   (<= (abs (- (posn-x (ball-loc (worldstate-ball state)))
               (posn-x (rangle-loc (first (worldstate-rangle-list state))))))
       SPEC-DISTANCE)))

; which-rangle-hit-ball?
;
; Worldstate -> MaybeRangle
; checks, which rangle was hit by the ball
(check-expect (which-rangle-hit-ball? (make-worldstate (make-ball (make-posn 50 50)
                                                                  (make-vel 1 1))
                                                       52
                                                       (list (make-rangle (make-posn 70 50) RED)))) (make-rangle (make-posn 70 50)
                                                                                                                 RED))
(check-expect (which-rangle-hit-ball? (make-worldstate (make-ball (make-posn 100 50)
                                                                  (make-vel 1 1))
                                                       52
                                                       (list (make-rangle (make-posn 70 50) RED)))) #false)
(define (which-rangle-hit-ball? state)
  (cond
    [(empty? (worldstate-rangle-list state)) #false]
    [(cons? (worldstate-rangle-list state))
     (if (or
          (ball-hit-rangle-top/down? state)
          (ball-hit-rangle-left/right? state))
         (first (worldstate-rangle-list state))
         (which-rangle-hit-ball? (make-worldstate (worldstate-ball state)
                                                  (worldstate-racket state)
                                                  (rest (worldstate-rangle-list state)))))]))

; ball-hit-racket?
;
; Worldstate -> Boolean
; checks. whether the ball hit the racket or not
(check-expect (ball-hit-racket? (make-worldstate (make-ball (make-posn 50 180)
                                                            (make-vel 1 1))
                                                 50
                                                 RANGLE-LIST-1)) #true)
(check-expect (ball-hit-racket? (make-worldstate (make-ball (make-posn 80 30)
                                                            (make-vel 1 1))
                                                 50
                                                 RANGLE-LIST-1)) #false)
(define (ball-hit-racket? state)
  (and (>= (posn-y (ball-loc (worldstate-ball state))) 
           (- HEIGHT BALL-RADIUS RACKET-H))
       (<= (abs (- (posn-x (ball-loc (worldstate-ball state))) 
                   (worldstate-racket state))) 
           (/ RACKET-W 2))))
                                                 
; posn+vel
;
; Posn Vel -> Posn
; applies q to p and simulates the movement in one clock tick
(check-expect (posn+vel (make-posn 5 6) (make-vel 1 2))
              (make-posn 6 8))
(define (posn+vel p q)
  (make-posn (+ (posn-x p) (vel-delta-x q))
             (+ (posn-y p) (vel-delta-y q))))
 
; move-ball
;
; Ball -> Ball
; computes movement of ball in one clock tick
(check-expect (move-ball (make-ball (make-posn 20 30)
                                    (make-vel 5 10)))
              (make-ball (make-posn 25 40)
                         (make-vel 5 10)))
(define (move-ball ball)
  (make-ball (posn+vel (ball-loc ball)
                       (ball-velocity ball))
             (ball-velocity ball)))
 
; A Collision is either
; - "top"
; - "down"
; - "left"
; - "right"
; - "racket"
; - "rangle-top/down"
; - "rangle-left/right"
; - "none"
; interp. the location where a ball collides with a wall

; collision
;
; worldstate -> Collision
; detects with which of the walls or objects (if any) the ball collides
(check-expect (collision (make-worldstate (make-ball (make-posn 0 75) (make-vel 2 4)) 78 RANGLE-LIST-1))  "left")
(check-expect (collision (make-worldstate (make-ball (make-posn 15 HEIGHT) (make-vel 4 1)) 52 RANGLE-LIST-1)) "down")
(check-expect (collision (make-worldstate (make-ball (make-posn WIDTH 12) (make-vel 2 1)) 12 RANGLE-LIST-1))  "right")
(check-expect (collision (make-worldstate (make-ball (make-posn 15 0) (make-vel 0 3)) 74 RANGLE-LIST-1)) "top")
(check-expect (collision (make-worldstate (make-ball (make-posn 23 (- HEIGHT BALL-RADIUS RACKET-H)) (make-vel 1 -2)) 25 RANGLE-LIST-1)) "racket")
(check-expect (collision (make-worldstate (make-ball (make-posn 20 35) (make-vel 1 -1)) 56 RANGLE-LIST-1)) "rangle-top/down")
(check-expect (collision (make-worldstate (make-ball (make-posn 55 120) (make-vel 1 4)) 98 RANGLE-LIST-1)) "none")
(check-expect (collision (make-worldstate (make-ball (make-posn 90 85) (make-vel -1 1)) 45 RANGLE-LIST-1)) "rangle-left/right")
(define (collision state)
  (cond
    [(<= (posn-x (ball-loc (worldstate-ball state))) BALL-RADIUS)            "left"]
    [(<= (posn-y (ball-loc (worldstate-ball state))) BALL-RADIUS)            "top"]
    [(>= (posn-x (ball-loc (worldstate-ball state))) (- WIDTH BALL-RADIUS))  "right"]
    [(>= (posn-y (ball-loc (worldstate-ball state))) (- HEIGHT BALL-RADIUS)) "down"]
    [(ball-hit-racket? state)                                                "racket"]
    [(empty? (worldstate-rangle-list state))                                 "none"]
    [(ball-hit-rangle-left/right? state)                                     "rangle-left/right"]
    [(ball-hit-rangle-top/down? state)                                       "rangle-top/down"]
    [else (collision (make-worldstate (worldstate-ball state)
                                      (worldstate-racket state)
                                      (rest (worldstate-rangle-list state))))]))

; bounce
;
; Vel Collision -> Vel  
; computes the velocity of an object after a collision
(check-expect (bounce (make-vel 3 4) "left")
              (make-vel -3 4))
(check-expect (bounce (make-vel 3 4) "top")
              (make-vel 3 -4))
(check-expect (bounce (make-vel 3 4) "none")
              (make-vel 3 4))
(define (bounce vel collision)
  (cond [(or (string=? collision "left")
             (string=? collision "right")
             (string=? collision "rangle-left/right"))
         (make-vel (- (vel-delta-x vel))
                   (vel-delta-y vel))]
        [(and (string=? collision "racket")
              (> (vel-delta-y vel) 0))
         (make-vel (vel-delta-x vel)
                   (- (vel-delta-y vel)))]
        [(or (string=? collision "down")
             (string=? collision "top")
             (string=? collision "rangle-top/down"))
         (make-vel (vel-delta-x vel)
                   (- (vel-delta-y vel)))]
        [else vel]))
 
; render
;
; WorldState -> Image
; renders ball at its position
(check-expect (image? (render INITIAL-WORLD-STATE)) #true)
(check-expect (image? (render SECOND-WORLD-STATE)) #true)
(check-expect (image? (render WELCOME)) #true)
(check-expect (image? (render GAME-OVER)) #true)
(check-expect (image? (render WINNER)) #true)
(define (render state)
  (cond
    [(and (string? state) (string=? WELCOME state)) WELCOME-SCREEN]
    [(and (string? state) (string=? GAME-OVER state)) GAME-OVER-SCREEN]
    [(and (string? state) (string=? WINNER state)) WINNER-SCREEN]
    [(worldstate? state) (place-image BALL-IMG
                                      (posn-x (ball-loc (worldstate-ball state)))
                                      (posn-y (ball-loc (worldstate-ball state)))
                                      (place-image RACKET-IMG
                                                   (worldstate-racket state)
                                                   (- HEIGHT (/ RACKET-H 2))
                                                   (render-rangles (worldstate-rangle-list state))))]))
 
; tick
;
; WorldState -> WorldState
; moves ball to its next location
(check-expect (tick INITIAL-WORLD-STATE) INITIAL-WORLD-STATE)
(check-expect (tick THIRD-WORLD-STATE) THIRD-WORLD-STATE)
(check-expect (tick FIRST-WORLD-STATE) (make-worldstate (make-ball (make-posn 181 102) (make-vel 1 2)) 100 RANGLE-LIST-1))
(check-expect (tick (make-worldstate (make-ball (make-posn 45 190) (make-vel 2 1)) 140 RANGLE-LIST-1)) GAME-OVER)
(check-expect (tick WINNER) WINNER)
(check-expect (tick (make-worldstate (make-ball (make-posn 20 35) (make-vel 1 -1)) 56 (list RANGLE-1 RANGLE-2)))
              (make-worldstate (make-ball (make-posn 21 36) (make-vel 1 1)) 56 (list RANGLE-2)))
(check-expect (tick (make-worldstate (make-ball (make-posn 20 35) (make-vel 1 -1)) 56 (list RANGLE-1)))
              (make-worldstate (make-ball (make-posn 21 36) (make-vel 1 1)) 56 empty))
(check-expect (tick (make-worldstate (make-ball (make-posn 20 35) (make-vel 1 -1)) 56 empty))
              WINNER)
(define (tick state)
  (cond
    [(and (string? state) (string=? WELCOME state)) state]
    [(and (string? state) (string=? GAME-OVER state)) state]
    [(and (string? state) (string=? WINNER state)) state]
    [(worldstate? state) (cond
                           [(string=? "down" (collision state)) GAME-OVER]
                           [(empty? (worldstate-rangle-list state)) WINNER]
                           [else (make-worldstate (move-ball (make-ball (ball-loc (worldstate-ball state))
                                                                        (bounce (ball-velocity (worldstate-ball state))
                                                                                (collision state))))
                                                  (worldstate-racket state)
                                                  (if
                                                   (or (string=? "rangle-top/down" (collision state))
                                                       (string=? "rangle-left/right" (collision state))) 
                                                   (remove (which-rangle-hit-ball? state)
                                                           (worldstate-rangle-list state))
                                                   (worldstate-rangle-list state)))])]))
  

; mouse
;
; WorldState x y MouseEvent -> WorldState
; changes position of racket when moving mouse
(check-expect (mouse INITIAL-WORLD-STATE 45 24 MOVE) INITIAL-WORLD-STATE)
(check-expect (mouse INITIAL-WORLD-STATE 78 52 CLICK) FIRST-WORLD-STATE)
(check-expect (mouse SECOND-WORLD-STATE 98 75 MOVE) (make-worldstate SECOND-BALL 98 RANGLE-LIST-1))
(check-expect (mouse FIRST-WORLD-STATE 120 25 CLICK) FIRST-WORLD-STATE)
(check-expect (mouse THIRD-WORLD-STATE 45 63 MOVE) THIRD-WORLD-STATE)
(check-expect (mouse THIRD-WORLD-STATE 41 85 CLICK) INITIAL-WORLD-STATE)
(check-expect (mouse WINNER 45 52 MOVE) WINNER)
(check-expect (mouse WINNER 45 85 CLICK) WELCOME)
(define (mouse state x y event)
  (cond
    [(and (string? state) (string=? WELCOME state))(cond 
                                                     [(string=? event CLICK) FIRST-WORLD-STATE]
                                                     [else state])]
    [(and (string? state) (or (string=? WINNER state)
                              (string=? GAME-OVER state))) (cond
                                                             [(string=? event CLICK) INITIAL-WORLD-STATE]
                                                             [else state])]
    [(worldstate? state) (cond 
                           [(string=? event MOVE) (make-worldstate (worldstate-ball state)
                                                                   x
                                                                   (worldstate-rangle-list state))]
                           [else state])]))

 


(define (main state)
  (big-bang state 
            (on-tick tick 0.01)
            (to-draw render)
            (on-mouse mouse)))
 
; start with: (main INITIAL-WORLD-STATE)
